import es
import popuplib
import cfglib
import cmdlib
import popuplib

#plugin information
info = es.AddonInfo() 
info.name     = 'Last Five' 
info.version  = '1.0' 
info.url      = 'http://addons.eventscripts.com/addons/view/lastfive' 
info.basename = 'lastfive' 
info.author   = 'Errant'

'''
    Last Five
        Lists the last Five people to LEAVE your server
        With option to ban them
'''

config = cfglib.AddonCFG(es.getAddonPath("lastfive") + "/addon.cfg")
 
config.text("******************************")
config.text("  LASTFIVE SETTINGS")
config.text("******************************")
 
list_length      = config.cvar("lastfive_length",     5, "The length of the Last5 list")

config.write() # Writes the .cfg to file


lastfive = []

def load():
    # register the commands
    cmdlib.registerSayCommand('!lastfive', getLastFive, 'Allows admins to view the last five players to leave the server', 'lastfive', 'ADMIN', getLastFiveNoauth)
    cmdlib.registerSayCommand('lastfive', getLastFive, 'Allows admins to view the last five players to leave the server', 'lastfive', 'ADMIN', getLastFiveNoauth)
    config.execute()
    
def unload():
    # unreg the commands
    cmdlib.unregisterSayCommand('!lastfive')
    cmdlib.unregisterClientCommand('lastfive')
    
def humanize_time(secs):
    # turns the time difference into days, hrs, minutes, secs
    if secs < 60:
        return '%02ds' % secs
    mins, secs = divmod(secs, 60)
    if mins < 60:
        return '%02dm %02ds' % (mins, secs)
    hours, mins = divmod(mins, 60)
    if hours < 24:
        return '%02dh %02dm %02ds' % (hours, mins, secs)
    days, hours = divmod(hours, 24)
    return '%02dd %02dh %02dm %02ds' % (days,hours, mins, secs)
    
def getLastFive(userid,args):
    # if we have no players in the list
    if len(lastfive) == 0:
        # tell them
        es.tell(userid,'#green','Last Five: No players in list! wait for someone to leave')
        # then exit
        return
    # create and easy menu
    l5_pop = popuplib.easymenu('lastfive', '', menuhandler)
    l5_pop.settitle("The Last 5 Players")
    i = 0
    # iterate the last five
    for player in lastfive:
        l5_pop.addoption( i, "%s %s" % ( player[0], humanize_time(time.time() - player[2]) ) )
        i += 1
    # send to user
    l5_pop.send(userid)
    

def getLastFiveNoauth(userid,args):
    es.tell(userid,'#green','You are not authorised to run this command')
    
def menuhandler(userid, choice, popupname):
    # handle the popups
    if popupname == 'lastfive' and int(choice) in lastfive:
        # last five choice...
        player = lastfive[int(choice)]
        l5_details = popuplib.create('l5details_%i' % int(choice))
        l5_details.addline(player)
        l5_details.addline('Left %s ago' %  humanize_time(time.time() - player[2]) )
        l5_details.addline('Steam ID: %s' % player[1])
        l5_details.addline('->1. Ban forver')
        l5_details.addline('->2. Ban 1 hr')
        l5_details.addline('->3. Ban 1 day')
        l5_details.addline('->4. Ban 1 Week')
        l5_details.menuselect = menuhandler 
        l5_details.send(userid)
        
    if popupname.startswith('l5details_'):
        player = lastfive[int(popupname[10:])]
        bans = [0,60,1440,10080]
        banstr = ['ever',' 1hr',' 1 day',' 1 week']
        # ban them!
        es.server.queuecmd('banid %d %s kick;writeid' % (bans[choice],player[1]))
        es.msg('#green','Last Five :: %s was banned for%s' % (player[0],banstr[choice]))
            
        
def player_disconnect(ev):
    lastfive.append((ev['name'],ev['networkid'],time.time())) # push into the list
    if len(lastfive) > int(list_length):
        lastfive.pop(0) # and pop from the begining!
